package apioneshot

import (
	"git.sr.ht/~mil/mobroute/api/apirtdatabase"
	"git.sr.ht/~mil/mobroute/api/apirtdatabaseq"
	"git.sr.ht/~mil/mobroute/api/apirtinit"
	"git.sr.ht/~mil/mobroute/api/apirtroute"
	"git.sr.ht/~mil/mobroute/api/apirtschedule"
	"git.sr.ht/~mil/mobroute/api/apirtstops"
)

// OneShotRouteRequest groups both the MobrouteRuntimeConfig and RouteParams
type OneshotRouteRequest struct {
	MobrouteRuntimeConfig *apirtinit.MobrouteRuntimeConfig `json:"mobroute_runtime_config"`
	RouteParams           *apirtroute.RouteParams          `json:"route_params" validate:"required"`
}

// OneShotStopsRequest groups both the MobrouteRuntimeConfig and StopsParams
type OneshotStopsRequest struct {
	MobrouteRuntimeConfig *apirtinit.MobrouteRuntimeConfig `json:"mobroute_runtime_config"`
	StopsParams           *apirtstops.StopsParams          `json:"stops_params" validate:"required"`
}

// OneShotScheduleRequest groups both the MobrouteRuntimeConfig and StoptimesParams
type OneshotScheduleRequest struct {
	MobrouteRuntimeConfig *apirtinit.MobrouteRuntimeConfig `json:"mobroute_runtime_config"`
	ScheduleParams        *apirtschedule.ScheduleParams    `json:"schedule_params" validate:"required"`
}

// OneshotMobsqlRequest groups both the MobrouteRuntimeConfig and MobsqlParams
// for the mobsql request
type OneshotDatabaseRequest struct {
	MobrouteRuntimeConfig *apirtinit.MobrouteRuntimeConfig `json:"mobroute_runtime_config"`
	DatabaseParams        *apirtdatabase.DatabaseParams    `json:"database_params" validate:"required"`
}

// OneshotDatabaseqRequest groups both the MobrouteRuntimeConfig and DatabaseqParams
type OneshotDatabaseqRequest struct {
	MobrouteRuntimeConfig *apirtinit.MobrouteRuntimeConfig `json:"mobroute_runtime_config"`
	DatabaseqParams       *apirtdatabaseq.DatabaseqParams  `json:"databaseq_params" validate:"required"`
}
