package apirtdatabaseq

import (
	"fmt"

	"git.sr.ht/~mil/mobroute/api/apirtinit"
	"git.sr.ht/~mil/mobroute/util/utillog"
	"git.sr.ht/~mil/mobsql"
	"github.com/go-playground/validator/v10"
)

func RTDatabaseq(runtime *apirtinit.MobrouteRuntime, params *DatabaseqParams) (*DatabaseqResponse, error) {
	utillog.Infoj("Running RTDatabaseq against input", params)

	if err := validator.New(validator.WithRequiredStructEnabled()).Struct(params); err != nil {
		return nil, fmt.Errorf("Validation failed request: %v", err)
	} else if statuses, err := mobsql.FeedStatus(runtime.MobsqlRuntime, params.FeedIDs); err != nil {
		return nil, fmt.Errorf("FeedStatus error: %v", err)
	} else {
		return &statuses, nil
	}
}
