package diagnosticst

import "time"

// RouteDiagnostics contains diagnostic information for a routing request
// measuring number of seconds for specific parts of the pipeline,
// memory usage, and meta route information.
type RouteDiagnostics struct {
	PerfSMemloadConns     string `json:"perf_smemload_connections"`
	PerfSMemloadTransfers string `json:"perf_smemload_transfers"`
	PerfSMemloadWalksfrom string `json:"perf_smemload_walksfrom"`
	PerfSMemloadWalksto   string `json:"perf_smemload_walksto"`
	PerfSMemloadConnsverb string `json:"perf_smemload_connsverb"`
	PerfSRoute            string `json:"perf_sroute"`

	PerfNMemTransfers       int `json:"perf_nmemtransfers"`
	PerfNMemWalksfrom       int `json:"perf_nmemwalksfrom"`
	PerfNMemWalksfromNonnil int `json:"perf_nmemwalksfromnonnil"`
	PerfNMemWalksto         int `json:"perf_nmemwalksto"`
	PerfNMemWalkstoNonnil   int `json:"perf_nmemwalkstononnil"`
	PerfNMemConns           int `json:"perf_nmemconns"`

	PerfOptimizedFeeds []int `json:"perf_optimizedfeeds"`

	RouteinfoTransfers        uint      `json:"routeinfo_ntransfers"`
	RouteinfoDuration         uint      `json:"routeinfo_duration"`
	RouteinfoDurationWalkFrom uint      `json:"routeinfo_duration_walkfrom"`
	RouteinfoDurationWalkTo   uint      `json:"routeinfo_duration_walktto"`
	RouteinfoDurationTransit  uint      `json:"routeinfo_duration_transit"`
	RouteinfoDepart           time.Time `json:"routeinfo_depart"`
	RouteinfoArrive           time.Time `json:"routeinto_arrive"`
}
