package formatterdiagnostics

import (
	"git.sr.ht/~mil/mobroute/api/apirtroute/diagnosticst"
	"git.sr.ht/~mil/mobroute/api/apirtroute/formatterlegs"
)

func FormatDiagnosticsExtra(diagnostics *diagnosticst.RouteDiagnostics, legs *[]formatterlegs.RouteLeg) *diagnosticst.RouteDiagnostics {
	for _, leg := range *legs {
		if leg.LegType == "transfer" {
			diagnostics.RouteinfoTransfers += 1
		}
	}

	var (
		departAt = (*legs)[0].LegBeginTime
		arriveAt = (*legs)[len(*legs)-1].LegEndTime
		walkFrom = uint((*legs)[0].LegEndTime.Sub((*legs)[0].LegBeginTime).Seconds())
		walkTo   = uint((*legs)[len(*legs)-1].LegEndTime.Sub((*legs)[len(*legs)-1].LegBeginTime).Seconds())

		durationTotal    = uint(arriveAt.Sub(departAt).Seconds())
		durationWalkFrom = uint((*legs)[0].LegEndTime.Sub((*legs)[0].LegBeginTime).Seconds())
		durationWalkTo   = uint((*legs)[len(*legs)-1].LegEndTime.Sub((*legs)[len(*legs)-1].LegBeginTime).Seconds())
		durationTransit  = durationTotal - walkFrom - walkTo
	)

	diagnostics.RouteinfoDepart = departAt
	diagnostics.RouteinfoArrive = arriveAt
	diagnostics.RouteinfoDuration = durationTotal
	diagnostics.RouteinfoDurationWalkFrom = durationWalkFrom
	diagnostics.RouteinfoDurationWalkTo = durationWalkTo
	diagnostics.RouteinfoDurationTransit = durationTransit

	return diagnostics
}
