package formatterlegs

import (
	"time"

	"git.sr.ht/~mil/mobroute/util/utilfuncs"
)

func FormatLegWalk(
	coordFrom, coordTo [2]float64,
	labelFrom, labelTo string,
	beginWalkAtTime time.Time,
	walkspeedKmHr float64,
) *RouteLeg {
	var (
		walkDistKm = utilfuncs.DistHaversine(coordFrom, coordTo)
		walkSecs   = walkCalcSecs(walkDistKm, walkspeedKmHr)
	)

	return &RouteLeg{
		LegType:       "walk",
		LegDuration:   utilfuncs.DurationFormatSecs(walkSecs),
		LegFromCoords: coordFrom,
		LegToCoords:   coordTo,
		LegBeginTime:  beginWalkAtTime,
		LegEndTime:    beginWalkAtTime.Add(time.Duration(walkSecs) * time.Second),
		WalkFrom:      &labelFrom,
		WalkTo:        &labelTo,
		WalkDistKm:    &walkDistKm,
	}
}
