package apirtroute

import (
	"time"
)

type Timer struct {
	lastTime time.Time
}

func (t *Timer) Snapshot() string {
	now := time.Now()
	delta := now.Sub(t.lastTime)
	t.lastTime = now
	return delta.String()
}

func ptr[T any](a T) *T {
	return &a
}

func fif[T any](cond bool, trueVal, falseVal T) T {
	if cond {
		return trueVal
	} else {
		return falseVal
	}
}
