package apirtroute_test

import (
	"fmt"
	"git.sr.ht/~mil/mobroute/api/apirtinit"
	//"git.sr.ht/~mil/mobroute/api/apirtroute"
	"git.sr.ht/~mil/mobroute/testhelper"
	"os"
	"testing"
)

// Test_ApiRouteYMLGTFS is essentially just a wiring test (at this point)
// See the zip GTFS tests which model actual GTFS data for more realistic
// tests and lower-level SQL loader tests for subcomponents.
func Test_ApiRouteYMLGTFS(t *testing.T) {
	if mockMobilityDBCSV, gtfsZips, err := testhelper.PrepareMockMobilityDBMockFromGTFSYMLs(
		map[int]string{42: "../../testhelper/mockgtfs/gtfs_sample_0.yml"},
	); err != nil {
		t.Fatalf("Failed to prepare mock: %v", err)
	} else if sqliteDB, err := os.CreateTemp("", "mobroute_test_sqlite_*.db"); err != nil {
		t.Fatalf("Failed to create mock SQLite DB: %v", err)
	} else if _, err := apirtinit.RTInitialize(&apirtinit.MobrouteRuntimeConfig{
		MobsqlRuntimeConfig: apirtinit.MobsqlRuntimeConfig{
			MobilityDBCatalogCSVURI: fmt.Sprintf("file://%s", mockMobilityDBCSV),
			SQLiteDBPath:            sqliteDB.Name(),
			LogInfo:                 true,
			LogWarn:                 true,
			LogDebug:                true,
		},
	}); err != nil {
		t.Fatalf("Error: %v", err)
		//} else if _ , err := apirtroute.RTRoute(mrRuntime, &apirtroute.RouteParams{}); err != nil {  //TODO
		//	t.Fatalf("Error: %v", err)
	} else {
		for _, z := range gtfsZips {
			os.Remove(z)
		}
		os.Remove(mockMobilityDBCSV)
	}
}
