package apirtschedule

import (
	"time"
)

type ScheduleParams struct {
	FeedIDs    []int    `json:"feed_ids" validate:"required,gt=0"`
	StopIDs    []string `json:"stop_ids" validate:"required,gt=0"`
	MaxSeconds uint     `json:"max_seconds" validate:"required,gt=0"`

	// Non-required
	Time *time.Time `json:"time" validate:"required"` // Default: now
}

type ScheduleDeparture struct {
	StopSIDU       string     `db:"stop_sidu" json:"stop_sidu"`
	RouteShortName *string    `db:"route_short_name" json:"route_short_name,omitempty"`
	RouteLongName  *string    `db:"route_long_name" json:"route_long_name,omitempty"`
	TripHeadsign   *string    `db:"trip_headsign" json:"trip_headsign,omitempty"`
	DepartureTime  *time.Time `db:"departure_time" json:"departure_time"`
}

type ScheduleResponse struct {
	Schedule *[]ScheduleDeparture `json:"schedule,omitempty"`
}
