package csa

import (
	"git.sr.ht/~mil/mobroute/dbt"
)

// TransferPossibleBetweenConnections determines whether a transfer is possible
// given two connections, the transfers map, and implicit/max transfer secs.
func TransferPossibleBetweenConnections(
	transfersMap map[string]map[string]uint,
	fromConnection, toConnection *dbt.Connection,
	maxTransferSeconds uint,
) bool {
	if fromConnection == nil {
		return false
	}

	var transferCost *uint = nil
	if t, transferCostKnownA := transfersMap[fromConnection.ToSSIDU]; transferCostKnownA {
		if cost, transferCostKnownB := t[toConnection.FromSSIDU]; transferCostKnownB {
			ccost := cost
			transferCost = &ccost
		}
	}

	if transferCost == nil {
		return false
	} else {
		delta := toConnection.FromST - fromConnection.ToST
		return delta < int(maxTransferSeconds) && delta > int(*transferCost)
	}
}
