package csa_test

import (
	th "git.sr.ht/~mil/mobroute/csa_test/csa_testhelper"
	"git.sr.ht/~mil/mobroute/dbt"
)

var csaTestCaseTransfersOk = CSATestCase{
	Test: "transfers_ok: Handles transfers accounting for transfer costs (takes 4_0/4_1)",
	Args: CSAArgs{
		Connections: th.ReorderByDepartureTime([]dbt.Connection{
			{ConnID: "1_0", TripID: "1", FromSSIDU: "a", ToSSIDU: "b", FromST: 3, ToST: 10},
			{ConnID: "1_1", TripID: "1", FromSSIDU: "b", ToSSIDU: "c", FromST: 10, ToST: 20},

			{ConnID: "2_0", TripID: "2", FromSSIDU: "a", ToSSIDU: "d", FromST: 0, ToST: 1},
			{ConnID: "2_1", TripID: "2", FromSSIDU: "d", ToSSIDU: "e", FromST: 1, ToST: 2},
			{ConnID: "2_2", TripID: "2", FromSSIDU: "e", ToSSIDU: "f", FromST: 3, ToST: 4},
			{ConnID: "2_3", TripID: "2", FromSSIDU: "f", ToSSIDU: "c", FromST: 5, ToST: 6},

			{ConnID: "3_0", TripID: "3", FromSSIDU: "g", ToSSIDU: "h", FromST: 10, ToST: 12},
			{ConnID: "3_1", TripID: "3", FromSSIDU: "h", ToSSIDU: "f", FromST: 12, ToST: 16},

			{ConnID: "4_0", TripID: "4", FromSSIDU: "g", ToSSIDU: "h", FromST: 12, ToST: 13},
			{ConnID: "4_1", TripID: "4", FromSSIDU: "h", ToSSIDU: "f", FromST: 17, ToST: 20},
		}),
		Transfers: &[]dbt.Transfer{
			{FromSSIDU: "b", ToSSIDU: "g", TransferSeconds: 1},
		},
		WalkcostsOrigin: map[string]uint{
			"a": 0, "b": 999, "c": 999, "d": 999, "e": 999, "f": 999, "g": 999, "h": 999,
		},
		FromTime:           1,
		MaxTransferSeconds: 7,
		MaxNTransfers:      99,
	},
	Expect: map[string]CSATestArrivalDetails{
		"a": {1, "", 0},
		"b": {10, "1_0", 1},
		"c": {20, "1_1", 1},
		"d": {1000, "", 0},
		"e": {1000, "", 0},
		"f": {20, "4_1", 2},
		"g": {11, "1_0", 1},
		"h": {13, "4_0", 2},
	},
}
