package dbquery

import (
	"fmt"
	"git.sr.ht/~mil/mobroute/util/utilfuncs"
	"github.com/jmoiron/sqlx"
	"strconv"
	"strings"
)

func QueryFeedIDsLoadedAndComputed(
	DB *sqlx.DB,
	queryFeedIDs []int,
) error {
	var (
		// TODO: Should this just be a call to mobsql rather then a direct query?
		query = fmt.Sprintf(
			`select count(*) from _vfeedsmetadata where loaded = 1 and computed = 1 and feed_id in (%s)`,
			strings.Join(utilfuncs.ArrayWithValue(len(queryFeedIDs), "?"), ","),
		)
		params = utilfuncs.Anyify(utilfuncs.ArrayIntToArryString(queryFeedIDs))
	)

	if value, err := QueryValue(DB, query, params); err != nil {
		return err
	} else if nSourcesPrepared, err := strconv.Atoi(value); err != nil {
		return err
	} else if nSourcesPrepared != len(queryFeedIDs) {
		return fmt.Errorf("Not all requested feed IDs %v loaded & computed; run RTDatabase with load & compute", queryFeedIDs)
	} else {
		return nil
	}
}
