select * from (
  -- Implicit transfers
  select
    from_stop_sidu, from_stop_idu, from_stop_id, from_feed_id,
    to_stop_sidu, to_stop_idu, to_stop_id, to_feed_id,
    'i' as transfer_category,
    ? as transfer_seconds
  from _vtransfersimplicit
  union all

  -- Generated transfers
  select
    from_stop_sidu, from_stop_idu, from_stop_id, feed_id as from_feed_id,
    to_stop_sidu, to_stop_idu, to_stop_id, feed_id_pair as to_feed_id,
    'g' as transfer_category,
    -- Uses dist_km to determine seconds transfer cost; round up to min_seconds
    max(coalesce(cast(dist_km / ? * 60 * 60 as uint), ?), ?) as transfer_seconds
  from _cttransfersgen
  union all

  -- Feed transfers (transfers.txt)
  select
    from_stop_sidu, from_stop_idu, from_stop_id, feed_id as from_feed_id,
    to_stop_sidu, to_stop_idu, to_stop_id, feed_id_pair as to_feed_id,
    'f' as transfer_category,
    -- Uses min_transfer_time, else use dist_km; round up to min_seconds
    max(coalesce(min_transfer_time, cast(dist_km / ? * 60 * 60 as uint), ?), ?) as transfer_seconds
  from _vtransferstbl
) t
where (%s)
and transfer_seconds < ?
and transfer_category in (%s)
