package dbquery_test

import (
	"testing"

	"git.sr.ht/~mil/mobroute/util/utilfuncs"
)

// UTCify converts the given number of seconds for input day into its equivilant
// normalized from the provided timezone. For example NYC UTC delta is -5hr
// so if the input seconds were 44, would return (-5 * 60) + 44
func UTCify(t *testing.T, dateYYYYMMDD uint, timezone string, seconds uint) int {
	if deltaSeconds, err := utilfuncs.TimezoneToUTCDeltaSecs(dateYYYYMMDD, timezone); err != nil {
		t.Fatalf("Couldn't determine delta seconds for timezone (%s) / date (%d): %v", timezone, dateYYYYMMDD, err)
		return 0
	} else {
		return int(seconds) + deltaSeconds
	}
}
