pragma encoding = 'UTF-8';
pragma cache_size = -64000;
pragma auto_vaccum = 1;
pragma journal_mode = 'wal';
pragma synchronous = off;

-- Note in regards to using memory temp_store:
--   This seems more or less **essential** for Android on certain platforms.
--   
--   In testing two behaviors are present if mem temp_store not set:
--     1. RO Error raised on particular large data queries
--     2. Empty resultset and NO error (e.g. setting limit on same query
--        produces results however)
--
--   (2) in specific may be a bug in either SQLite mattn/go-sqlite3 
--   or less likely sqlite itself based on resource limits handling.
--
--   For now, we just set this to memory which makes (1) and (2)
--   dissapear, however long term, we may want to investigate
--   using the temp_store_directory and the "root" cause especially
--   in the case of (2).
pragma temp_store = memory;
