drop table if exists stops_ridx;
create virtual table stops_ridx using rtree(
   id int,
   lon_min real, lon_max real,
   lat_min real, lat_max real,
   feed_id real, dummy real,
   +stop_id text,
   +stop_lat real,
   +stop_lon real
);

insert into stops_ridx (feed_id, dummy, stop_id, stop_lat, stop_lon, lat_min, lat_max, lon_min, lon_max)
select
  s.feed_id,
  s.feed_id,
  s.stop_id,
  stop_lat,
  stop_lon, 
  stop_lat - (3.0 / 111.0) as min_lat,
  stop_lat + (3.0 / 111.0) as max_lat,
  stop_lon - (3.0 / (111.0 * cos(radians(stop_lat)))) as min_lon,
  stop_lon + (3.0 / (111.0 * cos(radians(stop_lat)))) as max_lon
from stops s join _vstopparent v on
  s.feed_id = v.feed_id and
  s.stop_id = v.stop_id and
  v.stop_id = v.parent_station
