package dbstubquery

import (
	"git.sr.ht/~mil/mobroute/util/utillog"
	"github.com/jmoiron/sqlx"
)

func queryToSlice[T any](DB *sqlx.DB, query string, params []any, intoSlice *[]T) error {
	utillog.Infof("Loading %s (%v) to memory", query, params)
	defer func() {
		utillog.Infof("Loaded %s (%v) to memory ok (len=%d)", query, params, len(*intoSlice))
	}()

	var item T
	if rows, err := DB.Queryx(query, params...); err != nil {
		return err
	} else {
		for rows.Next() {
			if err := rows.StructScan(&item); err != nil {
				return err
			}
			*intoSlice = append(*intoSlice, item)
		}
	}
	return nil
}
