package mobroute

import (
	"git.sr.ht/~mil/mobroute/api/apioneshot"
	"git.sr.ht/~mil/mobroute/api/apirtdatabase"
	"git.sr.ht/~mil/mobroute/api/apirtdatabaseq"
	"git.sr.ht/~mil/mobroute/api/apirtinit"
	"git.sr.ht/~mil/mobroute/api/apirtroute"
	"git.sr.ht/~mil/mobroute/api/apirtschedule"
	"git.sr.ht/~mil/mobroute/api/apirtstops"
)

// OneshotRoute performs routing in a one-shot / single function fashion.
// All parameters for the entire request are passed in the OneShotRouteRequest.
func OneshotRoute(r *OneshotRouteRequest) (*RouteResponse, error) {
	return apioneshot.OneshotRoute(r)
}

// TODO
func OneshotStops(r *OneshotStopsRequest) (*StopsResponse, error) {
	return apioneshot.OneshotStops(r)
}

// TODO
func OneshotSchedule(r *OneshotScheduleRequest) (*ScheduleResponse, error) {
	return apioneshot.OneshotSchedule(r)
}

// TODO
func OneshotDatabase(r *OneshotDatabaseRequest) (*DatabaseResponse, error) {
	return apioneshot.OneshotDatabase(r)
}

// TODO
func OneshotDatabaseq(r *OneshotDatabaseqRequest) (*DatabaseqResponse, error) {
	return apioneshot.OneshotDatabaseq(r)
}

// RTInitialize initializes a MobrouteRuntime which contains a passthrough
// to the MobsqlRuntime & some additional metadata.
func RTInitialize(params *MobrouteRuntimeConfig) (*MobrouteRuntime, error) {
	return apirtinit.RTInitialize(params)
}

// Route performs the routing logic, extracting from the DB the required
// data for CSA, running the CSA algorithm, going back to the DB to pull a few
// extra fields for presentation, and finally formatting the data into route
// legs for easy consumption.
func RTRoute(runtime *MobrouteRuntime, paramsGiven *RouteParams) (*RouteResponse, error) {
	return apirtroute.RTRoute(runtime, paramsGiven)
}

// TODO
func RTStops(runtime *MobrouteRuntime, paramsGiven *StopsParams) (*StopsResponse, error) {
	return apirtstops.RTStops(runtime, paramsGiven)
}

// TODO
func RTSchedule(runtime *MobrouteRuntime, paramsGiven *ScheduleParams) (*ScheduleResponse, error) {
	return apirtschedule.RTSchedule(runtime, paramsGiven)
}

// TODO
func RTDatabase(runtime *MobrouteRuntime, paramsGiven *DatabaseParams) (*DatabaseResponse, error) {
	return apirtdatabase.RTDatabase(runtime, paramsGiven)
}

// TODO
func RTDatabaseq(runtime *MobrouteRuntime, paramsGiven *DatabaseqParams) (*DatabaseqResponse, error) {
	return apirtdatabaseq.RTDatabaseq(runtime, paramsGiven)
}
