package mobroute

import (
	"git.sr.ht/~mil/mobroute/api/apioneshot"
	"git.sr.ht/~mil/mobroute/api/apirtdatabase"
	"git.sr.ht/~mil/mobroute/api/apirtdatabaseq"
	"git.sr.ht/~mil/mobroute/api/apirtinit"
	"git.sr.ht/~mil/mobroute/api/apirtroute"
	"git.sr.ht/~mil/mobroute/api/apirtroute/diagnosticst"
	"git.sr.ht/~mil/mobroute/api/apirtroute/formatterlegs"
	"git.sr.ht/~mil/mobroute/api/apirtschedule"
	"git.sr.ht/~mil/mobroute/api/apirtstops"
)

// Oneshot Library
// ====================================

// OneShotRouteRequest groups both the MobrouteRuntimeConfig and RouteParams
type OneshotRouteRequest = apioneshot.OneshotRouteRequest

// TODO
type OneshotStopsRequest = apioneshot.OneshotStopsRequest

// TODO
type OneshotScheduleRequest = apioneshot.OneshotScheduleRequest

// TODO
type OneshotDatabaseRequest = apioneshot.OneshotDatabaseRequest

// TODO
type OneshotDatabaseqRequest = apioneshot.OneshotDatabaseqRequest

// ====================================

// RTInit Library
// ====================================

// MobsqlRuntimeConfig is just an alias for Mobsql's RuntimeConfig, see
// mobsql.RuntimeConfig for further documentation.
type MobsqlRuntimeConfig = apirtinit.MobsqlRuntimeConfig

// MobrouteRuntimeConfig contains the MobsqlRuntimeConfig & potentially
// in the future some other Mobroute-specific properties for the common
// DB connection & Mobroute params.
type MobrouteRuntimeConfig = apirtinit.MobrouteRuntimeConfig

// MobrouteRuntime contains the database connection & MobsqlRuntime.
type MobrouteRuntime = apirtinit.MobrouteRuntime

// TODO
type StopsParams = apirtstops.StopsParams

// TODO
type StopsResponse = apirtstops.StopsResponse

// TODO
type ScheduleParams = apirtschedule.ScheduleParams

// TODO
type ScheduleResponse = apirtschedule.ScheduleResponse

// TODO
type DatabaseParams = apirtdatabase.DatabaseParams

// TODO
type DatabaseResponse = apirtdatabase.DatabaseResponse

// TODO
type DatabaseqParams = apirtdatabaseq.DatabaseqParams

// TODO
type DatabaseqResponse = apirtdatabaseq.DatabaseqResponse

// RTRoute

// RouteParams contains the parameters for a given route request.
type RouteParams = apirtroute.RouteParams

// RouteResponse is the response for a successful routing request.
type RouteResponse = apirtroute.RouteResponse

// RouteDiagnostics contains diagnostic information for a routing request
// measuring number of seconds for specific parts of the pipeline,
// memory usage, and meta route information.
type RouteDiagnostics = diagnosticst.RouteDiagnostics

// RouteLeg represents a 'leg' in a route which may be either of transfer,
// walk, or trip type (see the LegType field).
//
// The Leg* properties are always present, Trip*, Transfer*, and Walk* fields
// may be nonnil depending on the LegType field.
type RouteLeg = formatterlegs.RouteLeg

// RouteStopDetails represents a stop within a trip.
type RouteStopDetails = formatterlegs.RouteStopDetails
