#!/usr/bin/env sh
# This script is used to generate a CSV file resembling the mobility DB
# only with each entry's upstream GTFS URL replaced out with a URL
# we control (since the mobility DB is subject to change). We use this
# to generate the file api/apirtroute_test/mock/realistic_mobilitydb.csv

MOBDBURL="https://bit.ly/catalogs-csv"
GTFSDIR="https://ci.lrdu.org/tests_gtfs/"

MOBDBFILE="$(mktemp)"
curl -L "$MOBDBURL" > "$MOBDBFILE"
cat "$MOBDBFILE" | head -n1
ZIPS="$(curl "$GTFSDIR" | grep -oE 'gtfs_[^"<]+' | uniq | sort)"
for ZIP in $ZIPS; do
  FEEDID="$(echo $ZIP | grep -oE gtfs_[0-9]+ | grep -oE [0-9]+ )"
  LINE="$(cat "$MOBDBFILE" | grep -E "^$FEEDID,")"
  echo "$LINE" | sed -E "s#http[^,]+.zip#$GTFSDIR/$ZIP#g"
done
