package utilfuncs

import "math"

func DistHaversine(a, b [2]float64) float64 {
	phiA := (90.0 - a[0]) * math.Pi / 180.0
	phiB := (90.0 - b[0]) * math.Pi / 180.0
	thetaA := a[1] * math.Pi / 180.0
	thetaB := b[1] * math.Pi / 180.0
	c := math.Sin(phiA)*math.Sin(phiB)*math.Cos(thetaA-thetaB) + math.Cos(phiA)*math.Cos(phiB)
	arc := math.Acos(c)
	scaleKm := 6371.0
	dist := arc * scaleKm

	if math.IsNaN(dist) {
		return 0
	} else {
		return dist
	}
}
