package utilfuncs

import (
	"bytes"
	"html/template"
)

func TemplateExecute(templateStr string, context map[string]any) (string, error) {
	var resultBuffer bytes.Buffer
	if tmpl, err := template.New("tmpl").Parse(templateStr); err != nil {
		return "", err
	} else if err := tmpl.ExecuteTemplate(&resultBuffer, "tmpl", context); err != nil {
		return "", err
	} else {
		return resultBuffer.String(), nil
	}
}
